------------------------------------------------------------------------
r1793 | aja_ | 2016-11-18 20:08:56 +0100 (vie, 18 nov 2016) | 2 lines

Address some of the issues reported by CoverityScan


Index: examples/helloworld-base14/helloworld-base14.cpp
===================================================================
--- examples/helloworld-base14/helloworld-base14.cpp	(revision 1792)
+++ examples/helloworld-base14/helloworld-base14.cpp	(revision 1793)
@@ -174,7 +174,7 @@
 		 */
 		document.Close();
 
-	} catch ( const PdfError & e ) {
+	} catch ( PdfError & e ) {
 		/*
 		 * All PoDoFo methods may throw exceptions
 		 * make sure that painter.FinishPage() is called
@@ -221,7 +221,7 @@
          * with the filename of the output file as argument.
          */
          HelloWorld( argv[1] );
-    } catch( const PdfError & eCode ) {
+    } catch( PdfError & eCode ) {
         /*
          * We have to check if an error has occurred.
          * If yes, we return and print an error message
Index: examples/pdfcontentsgraph/PdfContentsGraph.cpp
===================================================================
--- examples/pdfcontentsgraph/PdfContentsGraph.cpp	(revision 1792)
+++ examples/pdfcontentsgraph/PdfContentsGraph.cpp	(revision 1793)
@@ -4,7 +4,6 @@
 #error This module requires boost::graph
 #endif
 
-#include <cassert>
 #include <string>
 #include <iostream>
 #include <map>
@@ -354,7 +353,7 @@
                 Vertex v = add_vertex( m_graph );
                 // Switch any waiting arguments into the new node's data.
                 m_graph[v].first.GetArgs().swap( args );
-                assert(!args.size());
+                PODOFO_ASSERT( !args.size() );
 
                 if (ki.kw == KW_Unknown)
                 {
@@ -361,40 +360,40 @@
                     // No idea what this keyword is. We have to assume it's an ordinary
                     // one, possibly with arguments, and just push it in as a node at the
                     // current level.
-                    assert(!m_graph[v].first.IsDefined());
+                    PODOFO_ASSERT( !m_graph[v].first.IsDefined() );
                     m_graph[v].first.SetKw( string(kwText) );
                     add_edge( parentage.top(), v, m_graph );
-                    assert( m_graph[v].first.GetKwId() == ki.kw );
-                    assert( m_graph[v].first.GetKwString() == kwText );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwId() == ki.kw );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwString() == kwText );
                 }
                 else if (ki.kt == KT_Standalone)
                 {
                     // Plain operator, shove it in the newly reserved vertex (which might already contain
                     // arguments) and add an edge from the top to it.
-                    assert(ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
-                    assert(!m_graph[v].first.IsDefined());
+                    PODOFO_ASSERT( ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
+                    PODOFO_ASSERT( !m_graph[v].first.IsDefined() );
                     m_graph[v].first.SetKw( ki.kw );
                     add_edge( parentage.top(), v, m_graph );
-                    assert( m_graph[v].first.GetKwId() == ki.kw );
-                    assert( m_graph[v].first.GetKwString() == kwText );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwId() == ki.kw );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwString() == kwText );
                 }
                 else if (ki.kt == KT_Opening)
                 {
                     PrintStack(m_graph, parentage, "OS: ");
-                    assert(ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
-                    assert(!m_graph[v].first.IsDefined());
+                    PODOFO_ASSERT( ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
+                    PODOFO_ASSERT( !m_graph[v].first.IsDefined() );
                     m_graph[v].first.SetKw( ki.kw );
                     // add an edge from the current top to it
                     add_edge( parentage.top(), v, m_graph );
                     // and push it to the top of the parentage stack
                     parentage.push( v );
-                    assert( m_graph[v].first.GetKwId() == ki.kw );
-                    assert( m_graph[v].first.GetKwString() == kwText );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwId() == ki.kw );
+                    PODOFO_ASSERT( m_graph[v].first.GetKwString() == kwText );
                     PrintStack(m_graph, parentage, "OF: ");
                 }
                 else
                 {
-                    assert(false);
+                    PODOFO_ASSERT( false );
                 }
             }
             else if (ki.kt == KT_Closing)
@@ -403,7 +402,7 @@
                 // be a node whose KWInstance is the matching opening keyword. We'll check
                 // that, then set the second KWInstance appropriately.
                 PrintStack(m_graph, parentage, "CS: ");
-                assert(ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
+                PODOFO_ASSERT( ki.kw != KW_Undefined && ki.kw != KW_Unknown && ki.kw != KW_RootNode );
                 // Get a reference to the node data for the current parent
                 NodeData & n ( m_graph[parentage.top()] );
                 PODOFO_RAISE_LOGIC_IF( n.second.IsDefined(), "Closing already closed group" );
@@ -411,7 +410,7 @@
                 // a valid match for
                 PdfContentStreamKeyword expectedCloseKw = n.first.GetKwInfo().kwClose;
                 // Ensure there aren't any args to the close kw
-                assert(!args.size());
+                PODOFO_ASSERT( !args.size() );
                 // and handle the close matching
                 if ( ki.kw != expectedCloseKw )
                 {
@@ -437,12 +436,12 @@
             }
             else
             {
-                assert(false);
+                PODOFO_ASSERT( false );
             }
         }
         else
         {
-            assert(false);
+            PODOFO_ASSERT( false );
         }
     }
 
Index: examples/pdfcontentsgraph/main.cpp
===================================================================
--- examples/pdfcontentsgraph/main.cpp	(revision 1792)
+++ examples/pdfcontentsgraph/main.cpp	(revision 1793)
@@ -85,7 +85,7 @@
             cout << " - page ok" << endl;
         }
     }
-    catch( const PdfError & e )
+    catch( PdfError & e )
     {
         e.PrintErrorMsg();
         return e.GetError();
Index: src/base/PdfDataType.h
===================================================================
--- src/base/PdfDataType.h	(revision 1792)
+++ src/base/PdfDataType.h	(revision 1793)
@@ -145,7 +145,7 @@
 {
     if(m_bImmutable) 
     {
-        throw PdfError( ePdfError_ChangeOnImmutable );
+        PODOFO_RAISE_ERROR( ePdfError_ChangeOnImmutable );
     }
 }
 
Index: src/base/PdfDate.cpp
===================================================================
--- src/base/PdfDate.cpp	(revision 1792)
+++ src/base/PdfDate.cpp	(revision 1793)
@@ -56,6 +56,8 @@
 PdfDate::PdfDate( const PdfString & sDate )
     : m_bValid( false )
 {
+    m_time = -1;
+
     if ( !sDate.IsValid() ) 
     {
         m_szDate[0] = 0;
Index: src/base/PdfDate.h
===================================================================
--- src/base/PdfDate.h	(revision 1792)
+++ src/base/PdfDate.h	(revision 1793)
@@ -130,7 +130,7 @@
 
  private:
     time_t m_time;
-    char   m_szDate[PDF_DATE_BUFFER_SIZE];
+    char   m_szDate[PDF_DATE_BUFFER_SIZE + 1]; // include also room for a nul-terminator in the buffer
 
     bool   m_bValid;
 };
Index: src/base/PdfFilter.cpp
===================================================================
--- src/base/PdfFilter.cpp	(revision 1792)
+++ src/base/PdfFilter.cpp	(revision 1793)
@@ -187,7 +187,7 @@
         try {
             m_filter->DecodeBlock( pBuffer, lLen );
         }
-        catch( const PdfError & e ) 
+        catch( PdfError & e ) 
         {
             m_bFilterFailed = true;
             throw e;
Index: src/base/PdfFilter.h
===================================================================
--- src/base/PdfFilter.h	(revision 1792)
+++ src/base/PdfFilter.h	(revision 1793)
@@ -326,7 +326,7 @@
 
 	try {
 		BeginEncodeImpl();
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -342,7 +342,7 @@
 
 	try {
 		EncodeBlockImpl(pBuffer, lLen);
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -358,7 +358,7 @@
 
 	try {
 		EndEncodeImpl();
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -378,7 +378,7 @@
 
 	try {
 		BeginDecodeImpl( pDecodeParms );
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -394,7 +394,7 @@
 
 	try {
 		DecodeBlockImpl(pBuffer, lLen);
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -410,7 +410,7 @@
 
 	try {
 	    EndDecodeImpl();
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 		// Clean up and close stream
 		this->FailEncodeDecode();
 		throw e;
@@ -442,7 +442,7 @@
     // Note that we can't do this for the user, since EndEncode() might
     // throw and we can't safely have that in a dtor. That also means
     // we can't throw here, but must abort.
-    assert(!m_pOutputStream);
+    assert( !m_pOutputStream );
 }
 
 
Index: src/base/PdfFiltersPrivate.cpp
===================================================================
--- src/base/PdfFiltersPrivate.cpp	(revision 1792)
+++ src/base/PdfFiltersPrivate.cpp	(revision 1793)
@@ -230,6 +230,11 @@
 // Hex
 // -------------------------------------------------------
 
+PdfHexFilter::PdfHexFilter()
+    : m_cDecodedByte( 0 ), m_bLow( true )
+{
+}
+
 void PdfHexFilter::EncodeBlockImpl( const char* pBuffer, pdf_long lLen )
 {
     char data[2];
@@ -301,6 +306,11 @@
 // Paul Haahr - http://www.webcom.com/~haahr/
 // -------------------------------------------------------
 
+PdfAscii85Filter::PdfAscii85Filter()
+    : m_count( 0 ), m_tuple( 0 )
+{
+}
+
 void PdfAscii85Filter::EncodeTuple( unsigned long tuple, int count )
 {
     int      i      = 5;
@@ -606,6 +616,11 @@
 // RLE
 // -------------------------------------------------------
 
+PdfRLEFilter::PdfRLEFilter()
+    : m_nCodeLen( 0 )
+{
+}
+
 void PdfRLEFilter::BeginEncodeImpl()
 {
     PODOFO_RAISE_ERROR( ePdfError_UnsupportedFilter );
@@ -862,6 +877,8 @@
 PdfDCTFilter::PdfDCTFilter()
     : m_pDevice( NULL )
 {
+    memset( &m_cinfo, 0, sizeof( struct jpeg_decompress_struct ) );
+    memset( &m_jerr, 0, sizeof( struct jpeg_error_mgr ) );
 }
 
 PdfDCTFilter::~PdfDCTFilter()
Index: src/base/PdfFiltersPrivate.h
===================================================================
--- src/base/PdfFiltersPrivate.h	(revision 1792)
+++ src/base/PdfFiltersPrivate.h	(revision 1793)
@@ -93,6 +93,8 @@
  */
 class PdfHexFilter : public PdfFilter {
  public:
+    PdfHexFilter();
+
     virtual ~PdfHexFilter() { }
 
     /** Check wether the encoding is implemented for this filter.
@@ -200,6 +202,7 @@
  */
 class PdfAscii85Filter : public PdfFilter {
  public:
+    PdfAscii85Filter();
     virtual ~PdfAscii85Filter() { }
 
     /** Check wether the encoding is implemented for this filter.
@@ -460,6 +463,7 @@
  */
 class PdfRLEFilter : public PdfFilter {
  public:
+    PdfRLEFilter();
     virtual ~PdfRLEFilter() {}
 
     /** Check wether the encoding is implemented for this filter.
Index: src/base/PdfImmediateWriter.cpp
===================================================================
--- src/base/PdfImmediateWriter.cpp	(revision 1792)
+++ src/base/PdfImmediateWriter.cpp	(revision 1793)
@@ -172,7 +172,7 @@
     if( pFileStream ) 
     {
         // Only one open file stream is allowed at a time
-        assert( !m_bOpenStream );
+        PODOFO_ASSERT( !m_bOpenStream );
         m_bOpenStream = true;
 
         if( m_pEncrypt )
@@ -186,7 +186,7 @@
     if( pFileStream ) 
     {
         // A PdfFileStream has to be opened before
-        assert( m_bOpenStream );
+        PODOFO_ASSERT( m_bOpenStream );
         m_bOpenStream = false;
     }
 }
Index: src/base/PdfInputStream.cpp
===================================================================
--- src/base/PdfInputStream.cpp	(revision 1792)
+++ src/base/PdfInputStream.cpp	(revision 1793)
@@ -91,10 +91,19 @@
     pdf_long lOffset = ftello( m_hFile );
     pdf_long lLen;
 
-    fseeko( m_hFile, 0L, SEEK_END );
+    if( lOffset == -1 )
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to read current position in the file" );
+
+    if( fseeko( m_hFile, 0L, SEEK_END ) == -1 )
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to seek at the end of the file" );
+
     lLen = ftello( m_hFile );
-    fseeko( m_hFile, lOffset, SEEK_SET );
+    if( lLen == -1 )
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to read file length" );
 
+    if( fseeko( m_hFile, lOffset, SEEK_SET ) == -1 )
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to seek back to the previous position of the file" );
+
     return lLen;
 }
 
Index: src/base/PdfLocale.cpp
===================================================================
--- src/base/PdfLocale.cpp	(revision 1792)
+++ src/base/PdfLocale.cpp	(revision 1793)
@@ -16,14 +16,14 @@
     try {
     	s.imbue( cachedLocale );
     } catch (const std::runtime_error & e) {
-        std::ostringstream s;
-        s << "Failed to set safe locale on stream being used for PDF I/O.";
-        s << "Locale set was: \"" << PdfIOLocale << "\".";
-        s << "Error reported by STL std::locale: \"" << e.what() << "\"";
+        std::ostringstream err;
+        err << "Failed to set safe locale on stream being used for PDF I/O.";
+        err << "Locale set was: \"" << PdfIOLocale << "\".";
+        err << "Error reported by STL std::locale: \"" << e.what() << "\"";
         // The info string is copied by PdfError so we're ok to just:
         PODOFO_RAISE_ERROR_INFO(
             ePdfError_InvalidDeviceOperation,
-            s.str().c_str()
+            err.str().c_str()
             );
     }
 #endif
Index: src/base/PdfMemStream.cpp
===================================================================
--- src/base/PdfMemStream.cpp	(revision 1792)
+++ src/base/PdfMemStream.cpp	(revision 1793)
@@ -87,8 +87,12 @@
     {
         m_pStream->Close();
 
-        if( !m_pBufferStream ) 
-            m_lLength = dynamic_cast<PdfBufferOutputStream*>(m_pStream)->GetLength();
+        if( !m_pBufferStream )
+        {
+            PdfBufferOutputStream* pBufferOutputStream = dynamic_cast<PdfBufferOutputStream*>(m_pStream);
+            if( pBufferOutputStream )
+                m_lLength = pBufferOutputStream->GetLength();
+        }
 
         delete m_pStream;
         m_pStream = NULL;
Index: src/base/PdfMemoryManagement.h
===================================================================
--- src/base/PdfMemoryManagement.h	(revision 1792)
+++ src/base/PdfMemoryManagement.h	(revision 1793)
@@ -34,7 +34,10 @@
 #ifndef _PDF_MEMORY_MANAGEMENT_H_
 #define _PDF_MEMORY_MANAGEMENT_H_
 
-#include "PdfDefines.h"
+// PdfMemoryManagement.h should not include PdfDefines.h, since it is included by it.
+// It should avoid depending on anything defined in PdfDefines.h .
+
+#include "podofoapi.h"
 #include <stdlib.h>
 
 namespace PoDoFo {
@@ -75,5 +78,5 @@
 
 };
 
-#endif // _PDF_XREF_STREAM_PARSER_OBJECT_H_
+#endif // _PDF_MEMORY_MANAGEMENT_H_
 
Index: src/base/PdfName.cpp
===================================================================
--- src/base/PdfName.cpp	(revision 1792)
+++ src/base/PdfName.cpp	(revision 1793)
@@ -176,7 +176,10 @@
 
 PdfName PdfName::FromEscaped( const char * pszName, pdf_long ilen )
 {
-    if( !ilen && pszName )
+    if( !pszName )
+        return PdfName();
+
+    if( !ilen )
         ilen = strlen( pszName );
 
     return PdfName(UnescapeName(pszName, ilen));
Index: src/base/PdfObject.cpp
===================================================================
--- src/base/PdfObject.cpp	(revision 1792)
+++ src/base/PdfObject.cpp	(revision 1793)
@@ -44,7 +44,6 @@
 
 #include <sstream>
 #include <fstream>
-#include <cassert>
 
 #include <string.h>
 
@@ -143,8 +142,8 @@
 
 #if defined(PODOFO_EXTRA_CHECKS)
     // Must've been demand loaded or already done
-    assert(DelayedLoadDone());
-    assert(DelayedStreamLoadDone());
+    PODOFO_ASSERT( DelayedLoadDone() );
+    PODOFO_ASSERT( DelayedStreamLoadDone() );
 #endif
 }
 
@@ -323,8 +322,8 @@
 
 #if defined(PODOFO_EXTRA_CHECKS)
     // Must've been demand loaded or already done
-    assert(DelayedLoadDone());
-    assert(DelayedStreamLoadDone());
+    PODOFO_ASSERT( DelayedLoadDone() );
+    PODOFO_ASSERT( DelayedStreamLoadDone() );
 #endif
 
     return *this;
Index: src/base/PdfOutputStream.cpp
===================================================================
--- src/base/PdfOutputStream.cpp	(revision 1792)
+++ src/base/PdfOutputStream.cpp	(revision 1793)
@@ -51,6 +51,11 @@
     }
 }
 
+PdfFileOutputStream::~PdfFileOutputStream()
+{
+    Close();
+}
+
 pdf_long PdfFileOutputStream::Write( const char* pBuffer, pdf_long lLen )
 {
     return fwrite( pBuffer, sizeof(char), lLen, m_hFile );
@@ -58,8 +63,11 @@
 
 void PdfFileOutputStream::Close() 
 {
-    if( m_hFile ) 
+    if( m_hFile )
+    {
         fclose( m_hFile );
+        m_hFile = NULL;
+    }
 }
 
 PdfMemoryOutputStream::PdfMemoryOutputStream( pdf_long lInitial )
Index: src/base/PdfOutputStream.h
===================================================================
--- src/base/PdfOutputStream.h	(revision 1792)
+++ src/base/PdfOutputStream.h	(revision 1793)
@@ -93,6 +93,8 @@
      */
     PdfFileOutputStream( const char* pszFilename );
 
+    virtual ~PdfFileOutputStream();
+
     /** Write data to the output stream
      *  
      *  \param pBuffer the data is read from this buffer
Index: src/base/PdfRefCountedInputDevice.cpp
===================================================================
--- src/base/PdfRefCountedInputDevice.cpp	(revision 1792)
+++ src/base/PdfRefCountedInputDevice.cpp	(revision 1793)
@@ -39,7 +39,7 @@
 
     try {
         m_pDevice->m_pDevice = new PdfInputDevice( pszFilename );
-    } catch( const PdfError & rError ) {
+    } catch( PdfError & rError ) {
         delete m_pDevice;
         throw rError;
     }
@@ -56,7 +56,7 @@
 
     try {
         m_pDevice->m_pDevice = new PdfInputDevice( pszFilename );
-    } catch( const PdfError & rError ) {
+    } catch( PdfError & rError ) {
         delete m_pDevice;
         throw rError;
     }
@@ -73,7 +73,7 @@
 
     try {
         m_pDevice->m_pDevice   = new PdfInputDevice( pBuffer, lLen );
-    } catch( const PdfError & rError ) {
+    } catch( PdfError & rError ) {
         delete m_pDevice;
         throw rError;
     }
Index: src/base/PdfStream.cpp
===================================================================
--- src/base/PdfStream.cpp	(revision 1792)
+++ src/base/PdfStream.cpp	(revision 1793)
@@ -71,7 +71,7 @@
             pDecodeStream->Write( const_cast<char*>(this->GetInternalBuffer()), this->GetInternalBufferSize() );
             pDecodeStream->Close();
         }
-        catch( const PdfError & e ) 
+        catch( PdfError & e ) 
         {
             delete pDecodeStream;
             throw e;
Index: src/base/PdfString.cpp
===================================================================
--- src/base/PdfString.cpp	(revision 1792)
+++ src/base/PdfString.cpp	(revision 1793)
@@ -1108,7 +1108,7 @@
             target += bytesToWrite;
         }
     }
-    catch( const PdfError & e ) 
+    catch( PdfError & e ) 
     {
         if( bOwnBuf )
             delete[] const_cast<pdf_utf16be *>(pszUtf16);
Index: src/base/PdfXRef.cpp
===================================================================
--- src/base/PdfXRef.cpp	(revision 1792)
+++ src/base/PdfXRef.cpp	(revision 1793)
@@ -92,7 +92,8 @@
     return false;
 }
 
-PdfXRef::PdfXRef() 
+PdfXRef::PdfXRef()
+    : m_offset( 0 )
 {
 
 }
Index: src/base/util/PdfMutexWrapper.h
===================================================================
--- src/base/util/PdfMutexWrapper.h	(revision 1792)
+++ src/base/util/PdfMutexWrapper.h	(revision 1793)
@@ -89,7 +89,7 @@
     try {
 	m_rMutex.UnLock();
     }
-    catch( const PdfError & rError ) 
+    catch( PdfError & rError ) 
     {
 	rError.PrintErrorMsg();
         throw rError;
Index: src/doc/PdfDocument.cpp
===================================================================
--- src/doc/PdfDocument.cpp	(revision 1792)
+++ src/doc/PdfDocument.cpp	(revision 1793)
@@ -544,7 +544,7 @@
                         }
                         else
                         {
-                            throw ePdfError_InvalidStream;
+                            PODOFO_RAISE_ERROR( ePdfError_InvalidStream );
                             break;
                         }
                     }
#Index: src/doc/PdfDocument.h
#===================================================================
#--- src/doc/PdfDocument.h	(revision 1792)
#+++ src/doc/PdfDocument.h	(revision 1793)
#@@ -694,8 +694,6 @@
## 
##     PdfOutlines*    m_pOutlines;
##     PdfNamesTree*   m_pNamesTree;
#     PdfNamesTree*   m_pNamesTree;
#     PdfPagesTree*   m_pPagesTree;
#     PdfAcroForm*    m_pAcroForms;
#-
#-    EPdfVersion     m_eVersion;
# };
# 
# // -----------------------------------------------------
Index: src/doc/PdfFontConfigWrapper.cpp
===================================================================
--- src/doc/PdfFontConfigWrapper.cpp	(revision 1792)
+++ src/doc/PdfFontConfigWrapper.cpp	(revision 1793)
@@ -57,6 +57,7 @@
 }
 
 PdfFontConfigWrapper::PdfFontConfigWrapper(const PdfFontConfigWrapper & rhs)
+    : m_pFontConfig( NULL )
 {
     this->operator=(rhs);
 }
Index: src/doc/PdfFontMetricsBase14.cpp
===================================================================
--- src/doc/PdfFontMetricsBase14.cpp	(revision 1792)
+++ src/doc/PdfFontMetricsBase14.cpp	(revision 1793)
@@ -144,7 +144,7 @@
 const char* PdfFontMetricsBase14::GetFontname() const 
 {
 #ifdef MYASSERT
-    assert(font_name != NULL);
+    PODOFO_ASSERT(font_name != NULL);
 #endif
     return font_name;
 }
Index: src/doc/PdfFontSimple.cpp
===================================================================
--- src/doc/PdfFontSimple.cpp	(revision 1792)
+++ src/doc/PdfFontSimple.cpp	(revision 1793)
@@ -56,6 +56,11 @@
 
 void PdfFontSimple::Init( bool bEmbed, const PdfName & rsSubType )
 {
+    if( !m_pEncoding )
+    {
+        PODOFO_RAISE_ERROR( ePdfError_InvalidHandle );
+    }
+
     PdfObject*    pWidth;
     PdfObject*    pDescriptor;
     PdfVariant    var;
#Index: src/doc/PdfFontTTFSubset.cpp
#===================================================================
#--- src/doc/PdfFontTTFSubset.cpp	(revision 1792)
#+++ src/doc/PdfFontTTFSubset.cpp	(revision 1793)
#@@ -173,7 +173,7 @@
#         if (it->tag == tag)
#             return it->offset;
#     }
#-    throw PdfError(ePdfError_InternalLogic, __FILE__, __LINE__, "table missing");
#+    PODOFO_RAISE_ERROR_INFO( ePdfError_InternalLogic, "table missing" );
# }
# 
# void PdfFontTTFSubset::GetNumberOfGlyphs()
#@@ -278,7 +278,7 @@
#     }
#     if ((tableMask & 0x3f )!= 0x3f) {
#         //std::cout << "ttfTables=" << std::hex << tableMask << std::dec << std::endl;
#-        throw PdfError(ePdfError_UnsupportedFontFormat, __FILE__, __LINE__, "Required TrueType table missing");
#+        PODOFO_RAISE_ERROR_INFO( ePdfError_UnsupportedFontFormat, "Required TrueType table missing" );
#     }
#     if ((tableMask & 0x0100 ) == 0x00) {
#         tbl.tag = TTAG_cmap;
#@@ -311,7 +311,7 @@
#         break;
#         case eFontFileType_Unknown:
#         default:
#-            throw PdfError(ePdfError_InternalLogic, __FILE__, __LINE__, "Invalid font type");
#+            PODOFO_RAISE_ERROR_INFO( ePdfError_InternalLogic, "Invalid font type" );
#     }
# }
# 
#@@ -407,7 +407,7 @@
#         }
#         return;
#     }
#-    throw PdfError(ePdfError_InternalLogic, __FILE__, __LINE__, "GID out of range");
#+    PODOFO_RAISE_ERROR_INFO( ePdfError_InternalLogic, "GID out of range" );
# }
# 
# void PdfFontTTFSubset::LoadCompound(GlyphContext& ctx, unsigned long offset)
#@@ -522,7 +522,7 @@
#     CodePointToGid::const_iterator it = usedCodes.lower_bound(gid);
#     do {
#         if (it == usedCodes.end()) {
#-            throw PdfError(ePdfError_InternalLogic, __FILE__, __LINE__, "Unexpected");
#+            PODOFO_RAISE_ERROR_INFO( ePdfError_InternalLogic, "Unexpected" );
#         }
#         m_sCMap.glyphArray.push_back(it->second);
#         ++it;
#@@ -811,8 +811,8 @@
#     //std::cout << " finalSize=" << tableOffset << " alloced=" << fontData.GetSize() << std::endl;
#     /* head table */
#     if (!headOffset) {
#-        throw PdfError(ePdfError_InternalLogic, __FILE__, __LINE__, "'head' table missing");
#-            }
#+        PODOFO_RAISE_ERROR_INFO( ePdfError_InternalLogic, "'head' table missing" );
#+    }
#     TTFWriteUInt32(bufp + headOffset + 8, TableCheksum(bufp, tableLength) - 0xB1B0AFBA);
# }
# 	    
Index: src/doc/PdfPagesTree.cpp
===================================================================
--- src/doc/PdfPagesTree.cpp	(revision 1792)
+++ src/doc/PdfPagesTree.cpp	(revision 1793)
@@ -836,7 +836,7 @@
     }
 
     // we should never exit from here - we should always have been able to return a page from above
-    // assert( false ) ;
+    // PODOFO_ASSERT( false ) ;
     return NULL;
 }
 */
Index: src/doc/PdfPainter.cpp
===================================================================
--- src/doc/PdfPainter.cpp	(revision 1792)
+++ src/doc/PdfPainter.cpp	(revision 1793)
@@ -146,7 +146,7 @@
         PdfError::LogMessage( eLogSeverity_Error, 
                               "PdfPainter::~PdfPainter(): FinishPage() has to be called after a page is completed!" );
 
-    assert(!m_pCanvas);
+    PODOFO_ASSERT( !m_pCanvas );
 }
 
 void PdfPainter::SetPage( PdfCanvas* pPage )
@@ -187,7 +187,7 @@
 	try { 
 		if( m_pCanvas )
 			m_pCanvas->EndAppend();
-	} catch( const PdfError & e ) {
+	} catch( PdfError & e ) {
 	    // clean up, even in case of error
 		m_pCanvas = NULL;
 		m_pPage   = NULL;
@@ -994,11 +994,11 @@
     // fast and easy individual characters access    
     const std::string& stringUtf8 = rsText.GetStringUtf8();
     std::vector<pdf_utf16be> stringUtf16(stringUtf8.length() + 1, 0);
-	assert(stringUtf16.size() > 0);	
+    PODOFO_ASSERT( stringUtf16.size() > 0 );
     const pdf_long converted = PdfString::ConvertUTF8toUTF16(
 	    reinterpret_cast<const pdf_utf8*>(stringUtf8.c_str()), &stringUtf16[0], stringUtf16.size());
 	//const pdf_long len = rsText.GetCharacterLength();
-    assert( converted == (rsText.GetCharacterLength() + 1) );
+    PODOFO_ASSERT( converted == (rsText.GetCharacterLength() + 1) );
 
 	const pdf_utf16be* const stringUtf16Begin = &stringUtf16[0];
     const pdf_utf16be* pszLineBegin = stringUtf16Begin;
Index: test/ContentParser/main.cpp
===================================================================
--- test/ContentParser/main.cpp	(revision 1792)
+++ test/ContentParser/main.cpp	(revision 1793)
@@ -173,7 +173,7 @@
             cout << " - page ok" << endl;
         }
     }
-    catch( const PdfError & e )
+    catch( PdfError & e )
     {
         e.PrintErrorMsg();
         return e.GetError();
